#include <stdio.h>
#include <stdlib.h>

#define MAX_CARS 20
#define MAX_LAPS 70

typedef struct {
 unsigned char minutes;
 unsigned char seconds;
 int milliseconds;
} Time;

typedef struct {
	int ncars;
	int nlaps;
} Race;

Race leitura(Time laps[MAX_CARS][MAX_LAPS]) {
	int i,j;
	FILE *dados;
	int carro, volta, minutos, segundos, milisegundos;
	Race race;
	
	race.ncars = 0;
	race.nlaps = 0;
	
	dados=fopen("corrida.dat","r");
	if (dados == NULL) {
		printf("Erro de leitura.\n");
		exit(EXIT_FAILURE);
	}	
	else {
		if ((fscanf(dados,"%d\n",&race.ncars)!=1)||(race.ncars>MAX_CARS)) {
			printf("Erro de leitura.\n");
			exit(EXIT_FAILURE);	
		};
		if ((fscanf(dados,"%d\n",&race.nlaps)!=1)||(race.nlaps>MAX_LAPS)) {
			printf("Erro de leitura.\n");
			exit(EXIT_FAILURE);	
		};
		for (i=0;i<race.ncars;i++) {
			for (j=0;j<race.nlaps;j++) {
				if (fscanf(dados,"%d %d %d:%d:%d\n",&carro,&volta,&minutos,&segundos,&milisegundos)!=5) {
					printf("Erro de leitura.\n");
					exit(EXIT_FAILURE);	
				};
				if ((carro != i)||(volta != j)) {
					printf("Erro de leitura.\n");
					exit(EXIT_FAILURE);
				};
				laps[carro][volta].minutes = minutos;
				laps[carro][volta].seconds = segundos;
				laps[carro][volta].milliseconds = milisegundos;
			}
		}
	}	
	return race;
}

int vencedor(Race race, Time laps[MAX_CARS][MAX_LAPS], int *menortempo) {
	
	int tempo [MAX_CARS];
	int i, j,winner;
	
	printf("%d\n",(int)menortempo);
	for (i=0; i<race.ncars; i++){
		tempo[i]=0;
		
		for (j=0; j<race.nlaps; j++){
			tempo [i] +=laps[i][j].minutes*60000+laps[i][j].seconds*1000+laps[i][j].milliseconds;
		}
	}

	(*menortempo) = tempo[0];
	winner = 0;
	
	for (i=1; i<race.ncars; i++){
		if (tempo[i]<(*menortempo)){
			(*menortempo) =tempo[i];
			winner=i;
		}
	}

	return winner;
}

int main() {
	
	int i,j;
	Time laps[MAX_CARS][MAX_LAPS];
	Race race;
	int tempo;

	race = leitura(laps);
	
	for(j=0;j<race.nlaps;j++) {
		printf("Volta: %d\n", j+1);
		for (i=0;i<race.ncars;i++) {
			printf("\tCarro:%d -> Tempo: %d:%d:%d\n",i+1,laps[i][j].minutes,laps[i][j].seconds,laps[i][j].milliseconds);					
		}
	}
	
	printf("\nO carro vencedor e: %d\n",vencedor(race,laps,&tempo)+1);
	printf("\nO tempo do carro vencedor e: %d ms\n",tempo);

	exit(EXIT_SUCCESS);

}